local mod = RW:Boss("Chromaggus", "Blackwing Lair")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_nefarion]]

---------------------------
-- Variables

-- Breats
local tBreat1CD, tBreat2CD

-- Enrage
local wEnrage

-- Frenzy
local wFrenzy

local phase

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		-- Register locale variables
		L.Unknown_Breath1 = "Unknown Breath 1"
		L.Unknown_Breath2 = "Unknown Breath 2"
		L.Breath1 = "Breath 1"
		L.Breath2 = "Breath 2"
		L.Breaths = "Breaths"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(14020)
	self:SetWin(14020)
	
	-- Breaths
	tBreat1CD		= self:CustomTimer(60, "%s", L.Breath1, [[Interface\Icons\INV_Misc_QuestionMark]], L.Breaths)
	tBreat2CD		= self:CustomTimer(60, "%s", L.Breath2, [[Interface\Icons\INV_Misc_QuestionMark]], L.Breaths)
	
	-- Enrage
	wEnrage			= self:CastWarning(23128)
	
	-- Frenzy 	
	wFrency			= self:CastWarning(23537)
	
	phase 			= self:PhaseMessage()
end

---------------------------
-- Locals
local ActiveBreaths = 0
local Breath1, Breath2

-- API Functions

function mod:OnEngage(trigger)
	self:Track("Breath", 
		23310, 23312, --Time Lapse
		23313, 23314, 33551, --Corrosive Acid
		23315, 23316, --Ignite Flesh
		23308, 23309, --Incinerate
		23187, 23189 --Frost Burn
		) -- Credit Bigwigs
	self:Track("Enrage", 23128)
	self:Track("Frenzy", 23537)
		
	tBreat1CD:Start(30, L.Unknown_Breath1)
	tBreat2CD:Start(L.Unknown_Breath2)
end

function mod:Breath(event, args)
	if event == "SPELL_CAST_START" then
		if not Breath1 then
			tBreat1CD:SetIcon(select(3, GetSpellInfo(args.spellID)))
			Breath1 = args.spellID
		elseif  not Breath2 then
			tBreat2CD:SetIcon(select(3, GetSpellInfo(args.spellID)))
			Breath2 = args.spellID
		end
		
		if args.spellID == Breath1 then
			tBreat1CD:Start(GetSpellInfo(Breath1))
		else
			tBreat2CD:Start(GetSpellInfo(Breath2))
		end
	end
end

function mod:Enrage(event, args)
	if event == "SPELL_AURA_APPLIED" then
		wEnrage:Show()
	end
end

function mod:Frenzy(event, args)
	if event == "SPELL_AURA_APPLIED" then
		wFrency:Show()
		phase:Show(2)
	end
end